uses bignum,crt,dos;
type
   st1 = string[1];
   stk = record
      stacktop: string;
      next: pointer;
   end;
var
   stackpointer : ^stk;
   i            :  byte;
   p            :  byte;
   stackempty   :  boolean;
   infix,rpn    :  string;
   bignumstr    :  string;
   t1,t2        :  string;
   translated   :  boolean;
   a,b,c,d,e,f,g,h:string;
   formula      :  array[1..8] of string;
   readchar     :  char;
   choice       :  byte;
   mainfile     :  text;

procedure Pop(var v: string);
   var
     pntr: pointer;
   begin
      if not stackempty then
         begin
            pntr := stackpointer^.next;
            v := stackpointer^.stacktop;
            dispose(stackpointer);
            stackpointer := pntr;
            if stackpointer = nil then
               stackempty := true;
         end;
   end;{pop}

procedure Push(var v: string);
   var
      pntr: pointer;
   begin
      pntr := stackpointer;
      new(stackpointer);
      stackpointer^.next := pntr;
      stackpointer^.stacktop := v;
      stackempty := false;
   end;{push}

function Priority(c: st1): byte;
   var
      c2: char;
   begin
      c2 := c[1];
      case c2 of
         '(',')' : priority := 0;
         '+','-' : priority := 2;
         '*','/' : priority := 3;
     '!','','' : priority := 4
      else
         priority := 1;
      end;{case}
   end;{priority}

procedure Translate(infix: string; var rpn: string);
   var
      len: byte;
      pick,pickoff: string;
   begin
      stackpointer := nil;
      rpn := '';
      len := length(infix);
      for i := 1 to len do
         begin
            pick := infix[i];
            p := priority(pick);
            if p = 1 then
               rpn := rpn + pick
            else
               if p > 1 then   begin
                  while (stackpointer <> nil) and
                  (priority(stackpointer^.stacktop) >= p) do
                     begin
                        rpn := rpn + stackpointer^.stacktop;
                        pop(pickoff);
                     end;
                  push(pick); end
               else
                  if pick = '(' then
                     push(pick)
                  else
                     if pick = ')' then
                        begin
                           while stackpointer^.stacktop <>'(' do
                              begin
                                 rpn := rpn + stackpointer^.stacktop;
                                 pop(pickoff);
                              end;{while.  Strip left paren}
                           pop(pickoff);
                        end;
         end;{for}

      while stackpointer <> nil do
         begin
            pop(pickoff);
            rpn := rpn + pickoff;
         end;
   end;{Translate}

function Balance(infix: string): boolean;
   var
      parencount : shortint;
      count      : byte;
   begin
      parencount := 0;
      for count := 1 to length(infix) do
         begin
            if infix[count] = '(' then
               parencount := parencount + 1
            else
               if infix[count] = ')' then
                  parencount := parencount - 1;

            if parencount <0 then
               begin
                  balance := false;
                  exit;
               end;
         end;{for}

      if parencount >0 then
         balance := false
      else
         balance := true;
   end;{balance}

procedure Bignumify(rpn: string);
   var
      pickoff: char;
   begin
      bignumstr := '';
      translated := true;
      for i := 1 to length(rpn) do
         begin
            bignumstr := rpn[i];
            if (bignumstr <>'+') and (bignumstr <>'-') and
               (bignumstr <>'*') and (bignumstr <>'/') and
               (bignumstr <>'!') and (bignumstr <>'') and
               (bignumstr <>'') then
               push(bignumstr)
            else
               begin
                  pickoff := bignumstr[1];
                  case pickoff of
                  '+': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'PLUS('+t1+','+t2+',FALSE)';
                          push(bignumstr);
                       end;
                  '-': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'MINUS('+t1+','+t2+',FALSE)';
                          push(bignumstr);
                       end;
                  '*': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'TIMES('+t1+','+t2+',FALSE)';
                          push(bignumstr);
                       end;
                  '/': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'DIVIDE('+t1+','+t2+',FALSE,FALSE)';
                          push(bignumstr);
                       end;
                  '!': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'FAC('+t1+')';
                          push(bignumstr);
                       end;
                  '': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'SQUARE('+t1+')';
                          push(bignumstr);
                       end;
                  '': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := 'ROOT('+t1+')';
                          push(bignumstr);
                       end;
                       end;
                       end;
                       end;
      pop(bignumstr);
   end;{bignumify}

procedure Evaluate(rpn: string);
   var
      pickoff: char;
   begin
      bignumstr := '';
      translated := true;
      for i := 1 to length(rpn) do
         begin
            bignumstr := rpn[i];
            if (bignumstr <>'+') and (bignumstr <>'-') and
               (bignumstr <>'*') and (bignumstr <>'/') and
               (bignumstr <>'!') and (bignumstr <>'') and
               (bignumstr <>'') then
               begin
                  pickoff := bignumstr[1];
                  pickoff := upcase(pickoff);
                  case pickoff of
                     'A': bignumstr := a;
                     'B': bignumstr := b;
                     'C': bignumstr := c;
                     'D': bignumstr := d;
                     'E': bignumstr := e;
                     'F': bignumstr := f;
                     'G': bignumstr := g;
                     'H': bignumstr := h;
                  end;{case}
                  push(bignumstr)
               end
            else
               begin
                  pickoff := bignumstr[1];
                  case pickoff of
                  '+': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := plus(t1,t2,false);
                          push(bignumstr);
                       end;
                  '-': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := minus(t1,t2,false);
                          push(bignumstr);
                       end;
                  '*': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := times(t1,t2,false);
                          push(bignumstr);
                       end;
                  '/': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t2);
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := divide(t1,t2,false,false);
                          push(bignumstr);
                       end;
                  '!': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := fac(t1);
                          push(bignumstr);
                       end;
                  '': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := square(t1);
                          push(bignumstr);
                       end;
                  '': begin
                          if stackempty then
                             begin
                                translated := false;
                                exit;
                             end;
                          pop(t1);
                          bignumstr := root(t1);
                          push(bignumstr);
                       end;
                       end;
                       end;
                       end;
      pop(bignumstr);
   end;{bignumify}

procedure Evalval;
   var
      formu: byte;
      result: integer;
      which:  char;
      pick:   char;
      indx:   byte;
      as,bs,cs,ds,es,fs,gs,hs: boolean;
      st: text;
   begin
      clrscr;
      textcolor(yellow);
      which := 'y';
      while not(which in ['N','n']) do
         begin
            while not(which in ['1'..'8']) do
               begin
                  sound(880);
                  delay(50);
                  nosound;
                  clrscr;
                  gotoxy(1,8);
                  write('WHICH FORMULA DO YOU WISH TO EVALUATE (1-8)?');
                  which := readkey
               end;

            writeln(which);
            stackempty := true;
            val(which,formu,result);
            infix := formula[formu];

            if balance(infix) then
               begin
                  translate(infix,rpn);
                  writeln('INFIX=',INFIX);
                  writeln('RPN=',RPN);
               end
            else
               begin
                  writeln(infix);
                  writeln('Woops!  Parantheses aren''t balanced---I can''t evaluate this.');
               end;

            bignumify(rpn);
            if not translated then
               begin
                  writeln('Invalid RPN expression---Translation in error.');
                  bignumstr :='bad';
               end;
            writeln('BIGNUM FORMAT=',bignumstr);
            if not balance(bignumstr) then
               writeln('STRING EXPRESSION TOO LONG---BIGNUM FORMAT IN ERROR.');

            evaluate(rpn);
            writeln('RPN EVALUATION=',bignumstr);
            writeln('length of bignum expression=',length(bignumstr));
            while not stackempty do
               pop(t1);

           while not(which  in ['Y','y','N','n']) do
              begin
                 gotoxy(1,23);
                 write('Do you wish to save the results (y/n)?');
                 sound(880);
                 delay(50);
                 nosound;
                 which := readkey;
              end;

           if (which in ['y','Y']) then
              begin
                 append(mainfile);
                 writeln(mainfile,'Formula #',formu,',',' Formula :=',infix);
                 as := false;
                 bs := false;
                 cs := false;
                 ds := false;
                 es := false;
                 fs := false;
                 gs := false;
                 hs := false;
                 for indx := 1 to length(infix) do
                    begin
                       if infix <>'bad' then
                          begin
                             pick := infix[indx];
                             case pick of
                             'A','a': if not as then begin
                                         writeln(mainfile,'A=',a);
                                         as := true; end;
                             'B','b': if not bs then begin
                                         writeln(mainfile,'B=',b);
                                         bs := true; end;
                             'C','c': if not cs then begin
                                         writeln(mainfile,'C=',c);
                                         cs := true; end;
                             'D','d': if not ds then begin
                                         writeln(mainfile,'D=',d);
                                         ds := true; end;
                             'E','e': if not es then begin
                                         writeln(mainfile,'E=',e);
                                         es := true; end;
                             'F','f': if not fs then begin
                                         writeln(mainfile,'F=',f);
                                         fs := true; end;
                             'G','g': if not gs then begin
                                         writeln(mainfile,'G=',g);
                                         gs := true; end;
                             'H','h': if not hs then begin
                                         writeln(mainfile,'H=',h);
                                         hs := true; end;
                             end;{case}
                          end;
                    end;
                 writeln(mainfile,'Last BIGNUM EVALUATION=',bignumstr);
                 writeln(mainfile,'');
                 writeln(mainfile,'');
                 close(mainfile);
              end;

           which := '?';

           while not(which  in ['Y','y','N','n']) do
              begin
                 gotoxy(1,24);
                 write('Do you want to Evaluate more Formulas (y/n)?');
                 sound(880);
                 delay(50);
                 nosound;
                 which := readkey;
              end;

         end;{while}

      end;{evalval}

procedure accept(col,row,len: byte; var v: string; c2,r2: byte);
   var
      temp :  string;
      readit: char;
      c,r:    byte;
   begin
      c := col;
      r := row;
      temp := '';
      readit := ' ';
      while (readit <> chr(27)) and (len>0) do
         begin
            readit := readkey;
            if readit in ['0'..'9','+','-','.'] then
               begin
                  gotoxy(c,r);
                  write(readit);
                  temp := temp + readit;
                  c := c + 1;
                  len := len - 1;
                  if c>80 then
                     begin
                        c := 1;
                        r := r + 1;
                     end;
                  if r > 25 then
                     r := 1;
               end
            else
               if readit = chr(13) then
                  begin
                     v := temp;
                     exit;
                  end
               else
                  if readit = chr(27) then
                     exit
                  else
                     if (readit = chr(8)) and (len<>255) then
                        begin
                           c := c-1;
                           if c = 0 then
                              begin
                                 c := 80;
                                 r := r-1;
                              end;
                           if r<1 then
                              r := 25;
                           gotoxy(c,r);
                           write(' ');
                           gotoxy(c,r);
                           temp := copy(temp,1,length(temp)-1);
                           if len <>255 then
                              len := len + 1;
                        end
                     else
                        begin
                           sound(880);
                           delay(15);
                           nosound;
                        end;

            gotoxy(c2,r2);
            write('length of ',readchar,'=   ');
            gotoxy(c2+12,r2);
            write(length(temp));
         end;
         v := temp;
   end;{accept}

procedure accept2(col,row,len: byte; var v: string; c2,r2: byte);
   var
      temp :  string;
      readit: char;
      c,r:    byte;
   begin
      c := col;
      r := row;
      temp := '';
      readit := ' ';
      while (readit <> chr(27)) and (len>0) do
         begin
            readit := readkey;
            if readit in ['A'..'H','a'..'h','+','-','*','/','!','s','r','S','R','(',')'] then
               begin
                  gotoxy(c,r);
                  if (readit = 's') or (readit ='S') then
                     readit := chr(253)
                  else
                     if (readit = 'r') or (readit ='R') then
                        readit := chr(171);
                  write(readit);
                  temp := temp + readit;
                  c := c + 1;
                  len := len - 1;
                  if c>80 then
                     begin
                        c := 1;
                        r := r + 1;
                     end;
                  if r > 25 then
                     r := 1;
               end
            else
               if readit = chr(13) then
                  begin
                     v := temp;
                     exit;
                  end
               else
                  if readit = chr(27) then
                     exit
                  else
                     if (readit = chr(8)) and (len<>255) then
                        begin
                           c := c-1;
                           if c = 0 then
                              begin
                                 c := 80;
                                 r := r-1;
                              end;
                           if r<1 then
                              r := 25;
                           gotoxy(c,r);
                           write(' ');
                           gotoxy(c,r);
                           temp := copy(temp,1,length(temp)-1);
                           if len <>255 then
                              len := len + 1;
                        end
                     else
                        begin
                           sound(880);
                           delay(15);
                           nosound;
                        end;

            gotoxy(c2,r2);
            write('length of ',readchar,'=   ');
            gotoxy(c2+12,r2);
            write(length(temp));
         end;
         v := temp;
   end;{accept2}

procedure Setvar;
   var
      doloop: boolean;
   procedure varmenu;
      begin
         clrscr;
         highvideo;
         textcolor(white);
         gotoxy(30,1);
         write('Set VARIABLE Values.');
         gotoxy(28,8);
         write('YOU HAVE EIGHT VARIABLES:');
         lowvideo;
         gotoxy(29,9);
         write('A-STRING FOR BIGNUM.');
         gotoxy(29,10);
         write('B--STRING FOR BIGNUM.');
         gotoxy(29,11);
         write('C--STRING FOR... ...');
         gotoxy(29,12);
         write('D-... ...');
         gotoxy(29,13);
         write('E--... ...');
         gotoxy(29,14);
         write('F--');
         gotoxy(29,15);
         write('G--');
         gotoxy(29,16);
         write('H--STRING FOR BIGNUM.');
         gotoxy(36,17);
         write('I--EXIT');
         gotoxy(13,25);
         highvideo;
         textcolor(yellow+blink);
         write('ENTER LETTER FOR CHOICE OF VARIABLE YOU WANT TO CHANGE>');
         textcolor(white);
      end;{varmenu}

   procedure Newvar(var v: string);
      begin
         clrscr;
         gotoxy(34,1);
         highvideo;
         textcolor(white);
         write('Set Variables');
         lowvideo;
         textcolor(yellow);
         gotoxy(1,5);
         write(readchar,'=');
         write(v);
         highvideo;
         textcolor(yellow+blink);
         gotoxy(1,13);
         write('ENTER NEW VALUE FOR ',readchar,' BELOW>');
         gotoxy(27,25);
         write('PRESS <ESC> TO ABORT VARIABLE ENTRY.');
         textcolor(white);
         accept(1,14,255,v,34,13);
      end;{newvar}


   begin
      varmenu;
      readchar := ' ';
      doloop := readchar in ['A'..'I'];
      while not doloop do
         begin
            sound(110);
            delay(20);
            nosound;
            readchar := readkey;
            readchar := upcase(readchar);
            case readchar of
               'A': newvar(a);
               'B': newvar(b);
               'C': newvar(c);
               'D': newvar(d);
               'E': newvar(e);
               'F': newvar(f);
               'G': newvar(g);
               'H': newvar(h);
               'I': exit;
            end;{case}
            varmenu;
            readchar := ' ';
         end;
   end;

procedure Setfor;
   var
      doloop: boolean;
   procedure formenu;
      begin
         clrscr;
         highvideo;
         textcolor(white);
         gotoxy(31,1);
         write('Set FORMULA Values.');
         gotoxy(29,8);
         write('YOU HAVE EIGHT FORMULAS:');
         lowvideo;
         gotoxy(30,9);
         write('1-FORMULA FOR BIGNUM.');
         gotoxy(30,10);
         write('2-FORMULA FOR BIGNUM.');
         gotoxy(30,11);
         write('3--FORMULA FOR... ...');
         gotoxy(30,12);
         write('4-... ...');
         gotoxy(30,13);
         write('5--... ...');
         gotoxy(30,14);
         write('6--');
         gotoxy(30,15);
         write('7--');
         gotoxy(30,16);
         write('8--FORMULA FOR BIGNUM.');
         gotoxy(36,17);
         write('9--EXIT');
         gotoxy(14,25);
         highvideo;
         textcolor(yellow+blink);
         write('ENTER NUMBER FOR CHOICE OF FORMULA YOU WANT TO CHANGE>');
         textcolor(white);
      end;{formenu}

   procedure NewFOR(var v: string);
      begin
         clrscr;
         gotoxy(34,1);
         highvideo;
         textcolor(white);
         write('Set Formulas');
         lowvideo;
         textcolor(yellow);
         gotoxy(1,5);
         write(readchar,'=');
         write(v);
         highvideo;
         textcolor(yellow+blink);
         gotoxy(1,13);
         write('ENTER NEW VALUE FOR ',readchar,' BELOW>');
         gotoxy(23,25);
         write('PRESS <ESC> TO ABORT FORMULA ENTRY.');
         textcolor(white);
         accept2(1,14,255,v,34,13);
      end;{newFOR}


   begin
      formenu;
      readchar := ' ';
      doloop := readchar in ['1'..'9'];
      while not doloop do
         begin
            sound(110);
            delay(20);
            nosound;
            readchar := readkey;
            case readchar of
               '1': newfor(formula[1]);
               '2': newfor(formula[2]);
               '3': newfor(formula[3]);
               '4': newfor(formula[4]);
               '5': newfor(formula[5]);
               '6': newfor(formula[6]);
               '7': newfor(formula[7]);
               '8': newfor(formula[8]);
               '9': exit;
            end;{case}
            formenu;
            readchar := ' ';
         end;
   end;

procedure Loadval;
   var
      inf: text;
      bfile: string[30];
      i: byte;
   begin
      clrscr;
      gotoxy(1,13);
      write('Name of file to load>');
      readln(bfile);
      {$I-}
      assign(inf,bfile);
      reset(inf);
      {$I+}
      if ioresult <>0 then
         begin
            write('FILE DOES NOT EXIST!');
            sound(370);
            delay(2000);
            nosound;
         end
      else
         begin
            readln(inf,a);
            readln(inf,b);
            readln(inf,c);
            readln(inf,d);
            readln(inf,e);
            readln(inf,f);
            readln(inf,g);
            readln(inf,h);
            for i := 1 to 8 do
               readln(inf,formula[i]);
            close(inf);
         end;
   end;{loadval}

procedure Saveval;
   var
      outf: text;
      afile: string[30];
      i: byte;
   begin
      clrscr;
      gotoxy(1,13);
      write('Name of file to output>');
      readln(afile);
      assign(outf,afile);
      rewrite(outf);
      writeln(outf,a);
      writeln(outf,b);
      writeln(outf,c);
      writeln(outf,d);
      writeln(outf,e);
      writeln(outf,f);
      writeln(outf,g);
      writeln(outf,h);
      for i := 1 to 8 do
         writeln(outf,formula[i]);
      close(outf);
   end;{saveval}

procedure Mainmenu;
   begin
      clrscr;
      highvideo;
      textcolor(white);
      gotoxy(15,1);
      write('BIG_RPN---Copyright (C) 1990 by Stephen A. Theberge.');
      lowvideo;
      gotoxy(28,10);
      write('1---Set VARIABLE Values.');
      gotoxy(29,11);
      write('2---Set FORMULA Values.');
      gotoxy(29,12);
      write('3---LOAD Saved Values.');
      gotoxy(28,13);
      write('4---SAVE Current Values.');
      gotoxy(22,14);
      write('5---EVALUATE Formulas & Expressions.');
      gotoxy(36,15);
      write('6---STOP!');
      gotoxy(15,25);
      textcolor(yellow+blink);
      write('ENTER NUMBDR WHICH CORRESPONDS TO CHOICE YOU WANT>');
   end;

begin
   a :='?';
   b := '?';
   c := '?';
   d := '?';
   e := '?';
   f := '?';
   g := '?';
   h := '?';
   for i := 1 to 8 do
      formula[i] := '???';
   readchar := ' ';
   assign(mainfile,'big_rpn.out');
   rewrite(mainfile);
   close(mainfile);
   mainmenu;
   while (readchar <'1') or (readchar >'6') do
      begin
         sound(880);
         delay(20);
         nosound;
         readchar := readkey;
         choice := ord(readchar) - 48;

         case choice of
            1: setvar;
            2: setfor;
            3: loadval;
            4: saveval;
            5: evalval;
            6: exit
         end;{case}
         readchar := ' ';
         mainmenu;
      end;
end.